Subject: Re: [PATCH] compiler.h: don't use temporary variable in __compiletime_assert()

From: Johannes Berg <[email-masked]>
Date: Tue, 13 May 2014 11:26:24 +0200

Hi James,

> Subject: [PATCH] compiler.h: avoid sparse errors in
>  __compiletime_error_fallback()
> 
> Usually, BUG_ON and friends aren't even evaluated in sparse, but
> recently compiletime_assert_atomic_type() was added, and that now
> results in a sparse warning every time it is used.
> 
> The reason turns out to be the temporary variable, after it sparse no
> longer considers the value to be a constant, and results in a warning
> and an error. The error is the more annoying part of this as it
> suppresses any further warnings in the same file, hiding other problems.
> 
> Unfortunately the condition cannot be simply expanded out to avoid the
> temporary variable since it breaks compiletime_assert on old versions of
> GCC such as GCC 4.2.4 which the latest metag compiler is based on.
> 
> Therefore #ifndef __CHECKER__ out the __compiletime_error_fallback which
> uses the potentially negative size array to trigger a conditional
> compiler error, so that sparse doesn't see it.
> 
> Signed-off-by: James Hogan <[email-masked]>
> Cc: Johannes Berg <[email-masked]>
> Cc: Daniel Santos <[email-masked]>
> Cc: Luciano Coelho <[email-masked]>
> Cc: Peter Zijlstra <[email-masked]>
> Cc: Paul E. McKenney <[email-masked]>
> Cc: Andrew Morton <[email-masked]>

Acked-by: Johannes Berg <[email-masked]>

> It's not particularly pretty, if you can think of a better solution that
> doesn't break old GCC I'm all ears.

>  #ifndef __compiletime_error
>  # define __compiletime_error(message)
> -# define __compiletime_error_fallback(condition) \
> +/*
> + * Sparse complains of variable sized arrays due to the temporary variable in
> + * __compiletime_assert. Unfortunately we can't just expand it out to make
> + * sparse see a constant array size without breaking compiletime_assert on old
> + * versions of GCC (e.g. 4.2.4), so hide the array from sparse altogether.
> + */
> +# ifndef __CHECKER__
> +#  define __compiletime_error_fallback(condition) \
>  	do { ((void)sizeof(char[1 - 2 * condition])); } while (0)
> -#else
> +# endif
> +#endif
> +#ifndef __compiletime_error_fallback
>  # define __compiletime_error_fallback(condition) do { } while (0)
>  #endif

That's pretty much what I had in mind, I may have expressed it a bit
differently but the end result is the same.

Thanks,
johannes